library verilog;
use verilog.vl_types.all;
entity fifo is
    generic(
        LENGTH_ADD      : integer := 32;
        LENGTH_DATA     : integer := 8;
        ST_IDLE         : integer := 0;
        ST_REQ          : integer := 1;
        ST_OUT          : integer := 2;
        ST_DONE         : integer := 3;
        ST_FINISH       : integer := 4;
        ST_ERR          : integer := 5;
        Len             : integer := 12
    );
    port(
        CLK             : in     vl_logic;
        reset           : in     vl_logic;
        Data_o          : out    vl_logic_vector;
        WE_2            : out    vl_logic_vector(1 downto 0);
        ADD_2           : out    vl_logic_vector;
        ENABLE          : in     vl_logic;
        CLK_O           : out    vl_logic;
        Data_i          : in     vl_logic_vector;
        ADD_1           : out    vl_logic_vector;
        WE_1            : out    vl_logic_vector(1 downto 0);
        LED_OP          : out    vl_logic;
        LED_DONE        : out    vl_logic
    );
end fifo;
