`timescale 1ns/1ps
module reg_sram(Data, Q, Clock, WE, Address, EN);

parameter width = 8;
parameter depth = 1024;
parameter addr = 10;
/*
parameter width = 8;
parameter depth = 1024;
parameter addr = 32;
*/
input EN;
input Clock;
input WE;
input [addr-1:0] Address;
input [width-1:0] Data;
output wire [width-1:0] Q;

reg [width-1:0] mem_data [0:depth-1];
reg [width-1:0] temp_reg;

integer i;

always @(posedge Clock)
begin
	if(EN==1'b1)
	begin
		if(WE==1'b1)
			mem_data[Address] <= Data;
		else
			temp_reg <= mem_data[Address];
	end
end
assign Q = temp_reg; 
//assign #20 Q = mem_data[Address]; 

endmodule
